#include <VirtualWire.h>
const int receive_pin = 4; // Pin dove vengono ricevuti i dati
const int LED_13 = 13;
const int RELE = 5;
char INDIRIZZO = 'c';
void setup()
{
    pinMode(LED_13, OUTPUT);
    pinMode(RELE, OUTPUT);
    digitalWrite(LED_13, LOW);
    digitalWrite(RELE, LOW);
    delay(1000);
    vw_set_rx_pin(receive_pin); //Setta il pin per la ricezione dati
    vw_setup(2000);  // Bits per sec
    vw_rx_start();       // Start the receiver PLL running
}
void loop()
{   
    char buf[2];
    byte buflen = 2;
    vw_wait_rx(); //Attende l'arrivo del dato
    vw_get_message(buf, &buflen); //Legge il dato e la sua lunghezza 
    if(buf[0] == INDIRIZZO)
    {
      if(buf[1] == '1')
      {
        digitalWrite(LED_13, HIGH);
        digitalWrite(RELE, HIGH);
      }
      else
      {
        if(buf[1] == '0')
        {
          digitalWrite(LED_13, LOW);
          digitalWrite(RELE, LOW);
        }        
      }
    }    
}
