#include <SPI.h>
#include <Ethernet.h>
#include <VirtualWire.h>
byte mac[] = { 0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED }; //Indirizzo fisico della scheda Ethernet
byte ip[] = { 192,168,1, 89 }; //indirizzo IP della scheda Ethernet
EthernetServer server(80); //Porta 80 per il traffico in  HTML
String query;
byte i;
const int transmit_pin = 49;      //Il pin da dove i dati vengono trasmessi
const int transmit_en_pin = 48; //Ogni qualvolta viene trasmesso un dato questo pin va basso
char msg[2] = {}; //Array dove viene memorizzato il dato da spedire
char stato_a = '0';
char stato_b = '0';
char stato_c = '0';
char stato_d = '0';
char stato_e = '0';
char stato_f = '0';
char stato_g = '0';
char stato_h = '0';
char stato_i = '0';
char stato_l = '0';
char stato_m = '0';
char stato_n = '0';
char stato_o = '0';
char stato_p = '0';
char stato_q = '0';
char stato_r = '0';
char stato_s = '0';
char stato_t = '0';
char stato_u = '0';
char stato_v = '0';
void trasmetti_dato(char, char);
//*******************************QUI VALORI CHE POSSONO ESSERE CAMBIATI DALL'UTENTE (ENTRO QUESTI ASTERISCHI)*****************

String TITOLO = "COMANDO REMOTO ETHERNET By Fabio";
String RGB = "255, 204, 255"; //Colore di sfondo combinazione dei tre colori RGB
String U1 = "Utenza 01"; //Nomi per le utenze
String U2 = "Utenza 02";
String U3 = "Utenza 03";
String U4 = "Utenza 04";
String U5 = "Utenza 05";
String U6 = "Utenza 06";
String U7 = "Utenza 07";
String U8 = "Utenza 08";
String U9 = "Utenza 09";
String U10 = "Utenza 10";
String U11 = "Utenza 11";
String U12 = "Utenza 12";
String U13 = "Utenza 13";
String U14 = "Utenza 14";
String U15 = "Utenza 15";
String U16 = "Utenza 16";
String U17 = "Utenza 17";
String U18 = "Utenza 18";
String U19 = "Utenza 19";
String U20 = "Utenza 20";

//******************************************************************************

String colore1 = "white";
String colore2 = "white";
String colore3 = "white";
String colore4 = "white";
String colore5 = "white";
String colore6 = "white";
String colore7 = "white";
String colore8 = "white";
String colore9 = "white";
String colore10 = "white";
String colore11 = "white";
String colore12 = "white";
String colore13 = "white";
String colore14 = "white";
String colore15 = "white";
String colore16 = "white";
String colore17 = "white";
String colore18 = "white";
String colore19 = "white";
String colore20 = "white";

void setup()
{
  // Initialise the IO and ISR
  vw_set_tx_pin(transmit_pin); //Setta il pin di uscita dati
  vw_set_ptt_pin(transmit_en_pin); //Setta il pin PTT
  vw_set_ptt_inverted(true); // PTT attivo basso
  vw_setup(2000);   // Bits per sec
  query = String("");
  Ethernet.begin(mac, ip); //Inizializzazione Ethernet
  server.begin(); //Il server (Scheda Ethernet Arduino)si mette in ascolto  
}
void loop()
{
  trasmetti_dato('a', stato_a);
  trasmetti_dato('b', stato_b); 
  trasmetti_dato('c', stato_c);
  trasmetti_dato('d', stato_d);
  trasmetti_dato('e', stato_e);
  trasmetti_dato('f', stato_f);
  trasmetti_dato('g', stato_g); 
  trasmetti_dato('h', stato_h);
  trasmetti_dato('i', stato_i);
  trasmetti_dato('l', stato_l);
  trasmetti_dato('m', stato_m);
  trasmetti_dato('n', stato_n); 
  trasmetti_dato('o', stato_o);
  trasmetti_dato('p', stato_p);
  trasmetti_dato('q', stato_q);
  trasmetti_dato('r', stato_r);
  trasmetti_dato('s', stato_s); 
  trasmetti_dato('t', stato_t);
  trasmetti_dato('u', stato_u);
  trasmetti_dato('v', stato_v);
  EthernetClient client = server.available(); //server.available()restituisce "vero" se il client (browser sul nostro computer) invia messaggi, se no "falso" 
  if (client) // Se è arrivato una richesta (GET / HTTP/1.1 GET /favicon.ico HTTP/1.1)dal client l'IF esegue il suo corpo, se no torna a void loop.
  {
    while (client.connected()) //Il client rimane connesso fino a quando non è stato spedito l'ultimo carattere
    {
      if (client.available()) //client.available restituisce il numero di byte da leggere (se no da 0);
      {
        char c = client.read(); //Legge un byte alla volta
        query.concat(c); //lo concatena in query
     if (c == '\n') // Fintanto non legge il carattere \n seguita la lettura.
     {
       client.println("HTTP/1.1 200 OK"); //Se è stato letto il carattere /n, il server (Ethernet Arduino) risponde con le seguenti tre istruzioni.
       client.println("Content-Type: text/html");
       client.println();
       //Il programma salta alla riga 381 se nessun tasto è stato premuto o se c'è stata richiesta iniziale da parte del browser
//***********************************************           
       //Da qui seguenza di lettura dei tasti con toggle del pin e  cambio del colore del tasto
       if (query.indexOf("utenza1") > 0) 
       {
         
         if(colore1 == "white")
          {
            stato_a = '1';
           
            colore1 = "red";
          }
          else
          {
            stato_a = '0';
            
            colore1 = "white";
          }
       }
       if (query.indexOf("utenza2") > 0) 
       {      
          if(colore2 == "white")
          {
             stato_b = '1';
             
             colore2 = "red";
          }
          else
          {
             stato_b = '0';
            
             colore2 = "white";       
          }
        }     
        if (query.indexOf("utenza3") > 0) 
        {
          if(colore3 == "white")
          {
            stato_c = '1';
            
            colore3 = "red";
          }
          else
          {
            stato_c = '0';
            
            colore3 = "white";       
          }
        } 
        if (query.indexOf("utenza4") > 0) 
       {
          if(colore4 == "white")
          {
            stato_d = '1';
            
            colore4 = "red";
          }
          else
          {
            stato_d = '0';
           
            colore4 = "white";
          }
       }    
       if (query.indexOf("utenza5") > 0) 
       {
          if(colore5 == "white")
          {
            stato_e = '1';
           
            colore5 = "red";
          }
          else
          {
            stato_e = '0';
           
            colore5 = "white";
          }
       } 
       if (query.indexOf("utenza6") > 0) 
       {
          if(colore6 == "white")
          {
            stato_f = '1';
            
            colore6 = "red";
          }
          else
          {
            stato_f = '0';
           
            colore6 = "white";
          }
       }
       if (query.indexOf("utenza7") > 0) 
       {
          if(colore7 == "white")
          {
            stato_g = '1';
           
            colore7 = "red";
          }
          else
          {
           stato_g = '0';
          
            colore7 = "white";
          }
       }
       if (query.indexOf("utenza8") > 0) 
       {
          if(colore8 == "white")
          {
            stato_h = '1';
          
            colore8 = "red";
          }
          else
          {
            stato_h = '0';
           
            colore8 = "white";
          }
       }
       if (query.indexOf("utenza9") > 0) 
       {
          if(colore9 == "white")
          {
            stato_i = '1';
           
            colore9 = "red";
          }
          else
          {
            stato_i = '0';
           
            colore9 = "white";
          }
       }
       if (query.indexOf("10utenza") > 0) 
       {
          if(colore10 == "white")
          {
            stato_l = '1';
           
            colore10 = "red";
          }
          else
          {
            stato_l = '0';
           
            colore10 = "white";
          }
       }
       if (query.indexOf("11utenza") > 0) 
       {     
          if(colore11 == "white")
          {
            stato_m = '1';
        
            colore11 = "red";
          }
          else
          {
            stato_m = '0';
        
            colore11 = "white";
          }
       }
       if (query.indexOf("12utenza") > 0) 
       {
          if(colore12 == "white")
          {
            stato_n = '1';
           
            colore12 = "red";
          }
          else
          {
            stato_n = '1';
          
            colore12 = "white";       
          }
        }     
        if (query.indexOf("13utenza") > 0) 
        {
          if(colore13 == "white")
          {
            stato_o = '1';
           
            colore13 = "red";
          }
          else
          {
            stato_o = '0';
         
            colore13 = "white";       
          }
        } 
        if (query.indexOf("14utenza") > 0) 
       { 
          if(colore14 == "white")
          {
            stato_p = '1';
          
            colore14 = "red";
          }
          else
          {
            stato_p = '0';
            
            colore14 = "white";
          }
       }    
       if (query.indexOf("15utenza") > 0) 
       {
          if(colore15 == "white")
          {
            stato_q = '1';
           
            colore15 = "red";
          }
          else
          {
            stato_q = '0';
            
            colore15 = "white";
          }
       } 
       if (query.indexOf("16utenza") > 0) 
       {
          if(colore16 == "white")
          {
            stato_r = '1';
           
            colore16 = "red";
          }
          else
          {
            stato_r = '0';
           
            colore16 = "white";
          }
       }
       if (query.indexOf("17utenza") > 0) 
       {
          if(colore17 == "white")
          {
            stato_s = '1';
          
            colore17 = "red";
          }
          else
          {
            stato_s = '0';
           
            colore17 = "white";
          }
       }
       if (query.indexOf("18utenza") > 0) 
       {
          if(colore18 == "white")
          {
            stato_t = '1';
            
            colore18 = "red";
          }
          else
          {
            stato_t = '0';
           
            colore18 = "white";
          }
       }
       if (query.indexOf("19utenza") > 0) 
       {
          if(colore19 == "white")
          {
            stato_u = '1';
           
            colore19 = "red";
          }
          else
          {
            stato_u = '1';
           
            colore19 = "white";
          }
       }
       if (query.indexOf("20utenza") > 0) 
       {
          if(colore20 == "white")
          {
            stato_v = '1';
            
            colore20 = "red";
          }
          else
          {
            stato_v = '0';
            
            colore20 = "white";
          }
       }
          //Ivia la pagina con i tasti alla richiesta del browser, questo accade quando nella barra degli indirizzi si scrive l'IP di arduino.

          client.print("<head>");                                                                        //autoaggiornamento
          client.print("<meta http-equiv='refresh' content='5;URL= http://fabio-elettronico.ddns.net'>");//autoaggiornamento
          client.print("</head>");                                                                       //autoaggiornamento
          
          client.print("<body style='background-color: rgb(");
          client.print(RGB);
          client.print("); color: rgb(0, 0, 0);'alink='#ee0000' link='#0000ee' vlink='#551a8b'><br>");

          for(i = 0 ; i < 6 ; ++i)
            client.print("&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;");
          client.print(TITOLO);
          client.print("</br></br></br>");
          for(i = 0 ; i < 7 ; ++i)
            client.print("&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; ");
            
          client.print("<a href='/utenza1'><button style='background-color:");    
          client.print(colore1);
          client.print(";'>");
          client.print(U1);
          client.print("</button></a>");  

          client.print("&nbsp; &nbsp;&nbsp; &nbsp;<a href='/11utenza'><button style='background-color:");    
          client.print(colore11);
          client.print(";'>");
          client.print(U11);
          client.print("</button></a></br></br>");

          for(i = 0 ; i < 7 ; ++i)
            client.print("&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; ");
            
          client.print("<a href='/utenza2'><button style='background-color:");    
          client.print(colore2);
          client.print(";'>");
          client.print(U2);
          client.print("</button></a>");

          client.print("&nbsp; &nbsp;&nbsp; &nbsp;<a href='/12utenza'><button style='background-color:");    
          client.print(colore12);
          client.print(";'>");
          client.print(U12);
          client.print("</button></a></br></br>");

          for(i = 0 ; i < 7 ; ++i)
            client.print("&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; ");
            
          client.print("<a href='/utenza3'><button style='background-color:");    
          client.print(colore3);
          client.print(";'>");
          client.print(U3);
          client.print("</button></a>");

          client.print("&nbsp; &nbsp;&nbsp; &nbsp;<a href='/13utenza'><button style='background-color:");    
          client.print(colore13);
          client.print(";'>");
          client.print(U13);
          client.print("</button></a></br></br>");

          for(i = 0 ; i < 7 ; ++i)
            client.print("&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; ");

          client.print("<a href='/utenza4'><button style='background-color:");    
          client.print(colore4);
          client.print(";'>");
          client.print(U4);
          client.print("</button></a>");

          client.print("&nbsp; &nbsp;&nbsp; &nbsp;<a href='/14utenza'><button style='background-color:");    
          client.print(colore14);
          client.print(";'>");
          client.print(U14);
          client.print("</button></a></br></br>");

          for(i = 0 ; i < 7 ; ++i)
            client.print("&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; ");
          
          client.print("<a href='/utenza5'><button style='background-color:");    
          client.print(colore5);
          client.print(";'>");
          client.print(U5);
          client.print("</button></a>");

          client.print("&nbsp; &nbsp;&nbsp; &nbsp;<a href='/15utenza'><button style='background-color:");    
          client.print(colore15);
          client.print(";'>");
          client.print(U15);
          client.print("</button></a></br></br>");

          for(i = 0 ; i < 7 ; ++i)
            client.print("&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; ");
          
          client.print("<a href='/utenza6'><button style='background-color:");    
          client.print(colore6);
          client.print(";'>");
          client.print(U6);
          client.print("</button></a>");

          client.print("&nbsp; &nbsp;&nbsp; &nbsp;<a href='/16utenza'><button style='background-color:");    
          client.print(colore16);
          client.print(";'>");
          client.print(U16);
          client.print("</button></a></br></br>");

          for(i = 0 ; i < 7 ; ++i)
            client.print("&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; ");

          client.print("<a href='/utenza7'><button style='background-color:");    
          client.print(colore7);
          client.print(";'>");
          client.print(U7);
          client.print("</button></a>");

          client.print("&nbsp; &nbsp;&nbsp; &nbsp;<a href='/17utenza'><button style='background-color:");    
          client.print(colore17);
          client.print(";'>");
          client.print(U17);
          client.print("</button></a></br></br>"); 

          for(i = 0 ; i < 7 ; ++i)
            client.print("&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; ");
          
          client.print("<a href='/utenza8'><button style='background-color:");    
          client.print(colore8);
          client.print(";'>");
          client.print(U8);
          client.print("</button></a>");

          client.print("&nbsp; &nbsp;&nbsp; &nbsp;<a href='/18utenza'><button style='background-color:");    
          client.print(colore18);
          client.print(";'>");
          client.print(U18);
          client.print("</button></a></br></br>"); 

          for(i = 0 ; i < 7 ; ++i)
            client.print("&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; ");
          
          client.print("<a href='/utenza9'><button style='background-color:");    
          client.print(colore9);
          client.print(";'>");
          client.print(U9);
          client.print("</button></a>");

          client.print("&nbsp; &nbsp;&nbsp; &nbsp;<a href='/19utenza'><button style='background-color:");    
          client.print(colore19);
          client.print(";'>");
          client.print(U19);
          client.print("</button></a></br></br>");

          for(i = 0 ; i < 7 ; ++i)
            client.print("&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; ");
          
          client.print("<a href='/10utenza'><button style='background-color:");    
          client.print(colore10);
          client.print(";'>");
          client.print(U10);
          client.print("</button></a>");

          client.print("&nbsp; &nbsp;&nbsp; &nbsp;<a href='/20utenza'><button style='background-color:");    
          client.print(colore20);
          client.print(";'>");
          client.print(U20);
          client.print("</button></br></br>");
                   
//*******************************************************************************

          break;//Esce dal ciclo    
     }
   }
  }
    delay(1); //Quando il Server ha risposto ad Arduino e stampato la pagina HTML nel browser resetta il processo e torna ad ascoltare
    client.stop();
    query = String("");
  }
}
void trasmetti_dato(char x, char y)
{
  msg[0] = x;
  msg[1] = y;
         vw_send(msg, strlen(msg));                      //Spedisce il dato e la lunghezza dell'array
         vw_wait_tx();                                  // Wait until the whole message is gone
}
